using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ZedGraph;
using System.Drawing;
using System.Drawing.Imaging;

namespace DistribAnalyser
{
    class Program
    {
        static void Main(string[] args)
        {
            if (args.Length < 6)
            {
                System.Console.WriteLine("Usage: DistribAnalyser.exe <input> <prefix> <threads> <scale max> <bar width> <bar spacing>");
                return;
            } 
            else if (!ParseInputFile(args[0]))
            {
                System.Console.WriteLine("Unable to parse input file, aborting.");
                return;
            }

			//GraphTask gt = new GraphTask(workGroups,0,180,4,args[1]);
			//gt.Start();
			
            // Grab the commandline arguments.
            /*outputPrefix = args[1];
            maxScale = float.Parse(args[3]);
            barWidth = double.Parse(args[4]);
            minGap = float.Parse(args[5]);

			GraphTask gt = new GraphTask(workGroups,0,45,4,args[1]);

            PerformLoadBalance(Int16.Parse(args[2]));*/
			
			GraphTask[] gt = new GraphTask[4];
			int multiple = numSamples / 4;
			
			for(int i = 0; i < 4; ++i) {
				if( i == 0 ) 
					gt[i] = new GraphTask(workGroups,(multiple * i),(multiple * (i + 1)),4,args[1]);
				else 
					gt[i] = new GraphTask(workGroups,(multiple * i) + 1,(multiple * (i + 1)),4,args[1]);
				
				gt[i].Start();
			}
			
			for(int i = 0; i < 4; ++i) {
				gt[i].Join();
			}
			
			Console.WriteLine("All threads have finished executing.");
        }

        static bool ParseInputFile(string file)
        {
            if (!System.IO.File.Exists(file))
            {
                System.Console.WriteLine("Specified input file does not exist: {0}", file);
                return false;
            }
            
            string[] lines = System.IO.File.ReadAllLines(file);
            foreach (string line in lines)
            {
                if (numSamples == 180)
                    break;
                
                string[] split = line.Split(',');
                foreach (string group in split)
                {
                    // Skip blanks after the final comma.
                    if (group == "")
                        continue;

                    workGroups[numSamples,numGroups] = Int16.Parse(group);
                    ++numGroups;
                }

                ++numSamples;
                numGroups = 0;
            }
           
            return true;
        }

        /*static void PerformLoadBalance(int numThreads)
        {
            int j = -1;
            int[] threadWeight = new int[numThreads];
            int lessWeight = 0;

            for (int i = 0; i < numSamples; ++i)
            {
                j = -1;
                threadWeight[0] = 1;

                while (workGroups[i, ++j] != 0)
                {
                    lessWeight = 0;

                    for (int k = 0; k < numThreads; ++k)
                    {
                        if (threadWeight[k] < threadWeight[lessWeight])
                        {
                            lessWeight = k;
                        }
                    }

                    threadWeight[lessWeight] += workGroups[i,j];
                }

                OutputBarChart(threadWeight,numThreads);

                for (int k = 0; k < numThreads; ++k)
                {
                    threadWeight[k] = 0;
                }
            }
        }*/
		
        static string outputPrefix = string.Empty;
        static float maxScale = 0;
        static double barWidth = 0.0;
        static float minGap = 0.0f;
        static int currentGraph = 0;
        static int numSamples = 0;
        static int numGroups = 0;
        static int[,] workGroups = new int[180,2048];
    }
}
